#INCLUDE dtclass.h

DEFINE CLASS _DATE AS CUSTOM
   Name="_DATE"
   
   PROTECTED oTXT

   Century=1
   DateFormat=0
   DateMark="."
   Format=""
   InputMask=""
   
   AutoFillDate=0
   AutoFillDateMode=1
   AutoFillDateMode=_AFD_VFP
   DIME AutoFillDate_Data(2)
   AutoFillDate_Data(_AFD_VFP)=",D:0,PO:1,T:2,S:3,:4,P:5,SO:6,N:7,"
   AutoFillDate_Data(_AFD_NAV)=",P:0,D:0,PO:1,T:2,S:3,:4,P:5,SO:6,N:7,"

   oTXT=.NULL.

   PROCEDURE DateFormat_Access
      RETURN IIF(ISNULL(This.oTXT),This.DateFormat,This.oTXT.DateFormat)
   ENDPROC
   PROCEDURE DateFormat_Assign(luValue)
      This.DateFormat=luValue
      IF NOT ISNULL(This.oTXT)
         This.oTXT.DateFormat=luValue
      ENDIF
   ENDPROC
    
   PROCEDURE DateMark_Access
      RETURN IIF(ISNULL(This.oTXT),This.DateMark,This.oTXT.DateMark)
   ENDPROC
   PROCEDURE DateMark_Assign(luValue)
      This.DateMark=luValue
      IF NOT ISNULL(This.oTXT)
         This.oTXT.DateMark=luValue
      ENDIF
   ENDPROC

   PROCEDURE Format_Access
      RETURN IIF(ISNULL(This.oTXT),This.Format,This.oTXT.Format)
   ENDPROC
   PROCEDURE Format_Assign(luValue)
      This.Format=luValue
      IF NOT ISNULL(This.oTXT)
         This.oTXT.Format=luValue
      ENDIF
   ENDPROC

   PROCEDURE InputMask_Access
      RETURN IIF(ISNULL(This.oTXT),This.InputMask,This.oTXT.InputMask)
   ENDPROC
   PROCEDURE InputMask_Assign(luValue)
      This.InputMask=luValue
      IF NOT ISNULL(This.oTXT)
         This.oTXT.InputMask=luValue
      ENDIF
   ENDPROC

   PROCEDURE Century_Access
      RETURN IIF(ISNULL(This.oTXT),This.Century,This.oTXT.Century)
   ENDPROC
   PROCEDURE Century_Assign(luValue)
      This.Century=luValue
      IF NOT ISNULL(This.oTXT)
         This.oTXT.Century=luValue
      ENDIF
   ENDPROC

   PROCEDURE Init
      DECLARE INTEGER GetThreadLocale IN kernel32.dll AS __DTCLASS_GetThreadLocale
      DECLARE INTEGER GetLocaleInfo IN KERNEL32.DLL AS __DTCLASS_GetLocaleInfo INTEGER,INTEGER,STRING @,INTEGER 
   ENDPROC
   
   PROCEDURE ToDate(loTXT,lcDate) && Konverze datumu v etzcovm tvaru na datum
      * loTXT  - .NULL. nebo odkaz na textbox s datumem (Date/string)
      * lcDate - Datum v etzcovm typu

      * nejdve musm zjisti formtovn vstupu
      * pokud je formtovn Default, pak jej musm zjistit dle SET("DATE")
      * pak z datumu natu zvl᚝ den, msc a rok
      * pak natu aktuln formtovn datumu
      * nsledn slom datum, kter vrtm

      This.oTXT=loTXT
      LOCAL luDateFormat,ldDate,lcMask,lcDateStr,liLen,liD,liM,liY,lcND,llAutoFill,lcED,liCentury
      luDateFormat=This.GetDateFormat(This.DateFormat)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.

      DO CASE
         CASE m.luDateFormat=DateTF_Long && long

         CASE m.luDateFormat=DateTF_Short && short
              lcDateStr=This.GetShortDateFormatString(m.loTXT)

              * nyn dopl den, msc nebo rok, podle toho co chyb
              liY=AT(IIF(m.liCentury=1,"YYYY","YY"),m.lcDateStr)
              liM=AT("MM",m.lcDateStr)
              liD=AT("DD",m.lcDateStr)
              lcDateStr="^"+STR(m.liY,1)+STR(m.liY+1,1)+IIF(m.liCentury=1,STR(m.liY+2,1)+STR(m.liY+3,1),"")+"-"+STR(m.liM,1)+STR(m.liM+1,1)+"-"+STR(m.liD,1)+STR(m.liD+1,1)

         CASE INLIST(m.luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY)
              * nyn otestuj co chyb
              liY=7
              liM=1
              liD=4
              lcDateStr=IIF(m.liCentury=1,"^7890-12-45","^78-12-45")

         CASE INLIST(m.luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD)
              liY=1
              liM=IIF(m.liCentury=1,6,4)
              liD=IIF(m.liCentury=1,9,7)
              lcDateStr=IIF(m.liCentury=1,"^1234-67-90","^12-45-78")

         OTHERWISE
              liY=7
              liM=4
              liD=1
              lcDateStr=IIF(m.liCentury=1,"^7890-45-12","^78-45-12")

      ENDCASE

      IF This.AutoFillDate=1
         lcED=This.GetStringBlankDate(m.loTXT)
         IF lcED#m.lcDate
            lcND=This.GetAutomaticDate(m.lcDate,m.liY,m.liM,m.liD)
            IF !ISNULL(m.lcND)
               lcDate=m.lcND
            ELSE
               llAutoFill=.T.
            ENDIF
         ELSE
            llAutoFill=lcED#m.lcDate
         ENDIF

         IF m.llAutoFill
            * kontrola na przdn msta
            IF EMPTY(SUBS(m.lcDate,liY,IIF(m.liCentury=1,4,2)))
               lcDate=STUFF(m.lcDate,liY,IIF(m.liCentury=1,4,2),STR(YEAR(DATE()),IIF(m.liCentury=1,4,2)))
            ENDIF
            IF EMPTY(SUBS(m.lcDate,m.liM,2))
               lcDate=STUFF(m.lcDate,m.liM,2,PADL(MONTH(DATE()),2,"0"))
            ENDIF
            IF EMPTY(SUBS(m.lcDate,m.liD,2))
               lcDate=STUFF(m.lcDate,m.liD,2,PADL(DAY(DATE()),2,"0"))  && "01"
            ENDIF
         ENDIF
      ENDIF
      RETURN CTOD(CHRTRAN(m.lcDateStr,IIF(m.liCentury=1,"1234567890","12345678"),m.lcDate))
   ENDPROC
   
   PROCEDURE ToString(loTXT,ldDate) && Konverze datumu na etzec
      * loTXT  - .NULL. nebo odkaz na textbox s datumem (Date/string)
      * ldDate - Datum

      * nejdve musm zjisti formtovn vstupu
      * pokud je formtovn Default, pak jej musm zjistit dle SET("DATE")
      * pak z datumu natu zvl᚝ den, msc a rok
      * datumov oddlova se nat z vlastnosti DateMark
      * pokud je EMPTY(), pak se bere z nastaven SET("MARK")
      * nsledn slom etzec, kter vrtm

      This.oTXT=loTXT
      LOCAL luDateFormat,lcDateMark,lcDate,liCentury
      luDateFormat=This.GetDateFormat(This.DateFormat)
      lcDateMark=IIF(EMPTY(This.DateMark),SET("MARK"),This.DateMark)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.

      IF luDateFormat=DateTF_Short && short
         * formtovn datumu
         lcDate=STRTRAN(This.GetShortDateFormatString(m.loTXT),"#",m.lcDateMark)

         lcDate=STRTRAN(m.lcDate,REPL("D",OCCURS("D",m.lcDate)),STR(DAY(m.ldDate),2))
         lcDate=STRTRAN(m.lcDate,REPL("M",OCCURS("M",m.lcDate)),STR(MONTH(m.ldDate),2))
         lcDate=STRTRAN(m.lcDate,REPL("Y",OCCURS("Y",m.lcDate)),STR(YEAR(m.ldDate),IIF(m.liCentury=1,4,2)))
      ELSE
         IF luDateFormat=DateTF_Long
         ELSE
            * mm/dd/yy   MDY
            * yy.mm.dd   YMD
            * dd/mm/yy   DMY
            IF m.liCentury=1
               lcDate=CHRTRAN(;
                              IIF(INLIST(luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY),"56"+m.lcDateMark+"78"+m.lcDateMark+"1234",;
                              IIF(INLIST(luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD),"1234"+m.lcDateMark+"56"+m.lcDateMark+"78","78"+lcDateMark+"56"+lcDateMark+"1234")),;
                      "12345678",DTOS(m.ldDate))
            ELSE
               lcDate=CHRTRAN(;
                              IIF(INLIST(luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY),"56"+m.lcDateMark+"78"+m.lcDateMark+"34",;
                              IIF(INLIST(luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD),"34"+m.lcDateMark+"56"+m.lcDateMark+"78","78"+lcDateMark+"56"+lcDateMark+"34")),;
                      "12345678",DTOS(m.ldDate))
            ENDIF          
         ENDIF
      ENDIF
      RETURN m.lcDate   
   ENDPROC
   
   
   PROCEDURE GetCentury(liCentury) && Vrt nastaven Century
      RETURN IIF(m.liCentury<>2,m.liCentury,IIF(SET("CENTURY")="OFF",0,1))
   ENDPROC
   
   PROCEDURE GetDateFormat(luDateFormat) && Vrt nastaven DateFormat
      IF m.luDateFormat<>DateTF_Default
         RETURN m.luDateFormat
      ENDIF   
      
      luDateFormat=SET("DATE")

      RETURN IIF(m.luDateFormat=DateTF_American_Name,DateTF_American,;
             IIF(m.luDateFormat=DateTF_Ansi_Name,DateTF_Ansi,;
             IIF(m.luDateFormat=DateTF_British_Name,DateTF_British,;
             IIF(m.luDateFormat=DateTF_Italian_Name,DateTF_Italian,;
             IIF(m.luDateFormat=DateTF_French_Name,DateTF_French,;
             IIF(m.luDateFormat=DateTF_German_Name,DateTF_German,;
             IIF(m.luDateFormat=DateTF_Japan_Name,DateTF_Japan,;
             IIF(m.luDateFormat=DateTF_Taiwan_Name,DateTF_Taiwan,;
             IIF(m.luDateFormat=DateTF_USA_Name,DateTF_USA,;
             IIF(m.luDateFormat=DateTF_MDY_Name,DateTF_MDY,;
             IIF(m.luDateFormat=DateTF_DMY_Name,DateTF_DMY,;
             IIF(m.luDateFormat=DateTF_YMD_Name,DateTF_YMD,;
             IIF(m.luDateFormat=DateTF_Short_Name,DateTF_Short,;
             IIF(m.luDateFormat=DateTF_Long_Name,DateTF_Long,m.luDateFormat))))))))))))))
   ENDPROC

   PROCEDURE GetShortDateFormatString(loTXT) && Vrt formtovac etzec pro Short Date
      * loTXT  - .NULL. nebo odkaz na textbox s datumem (Date/string)
      This.oTXT=loTXT
      LOCAL luDateFormat,lcDateMark,lcMask,lcDateStr,liLen,liCentury
      lcDateMark=IIF(EMPTY(This.DateMark),SET("MARK"),This.DateMark)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.
      lcMask=IIF(m.liCentury=1,"99#99#9999","99#99#99")

      lcDateMark=SPACE(254)+CHR(0)
      lcDateStr=SPACE(254)+CHR(0)

      * formtovn datumu
      liLen=__DTCLASS_GetLocaleInfo(__DTCLASS_GetThreadLocale(),LOCALE_SSHORTDATE,@m.lcDateStr,LEN(m.lcDateStr))
      lcDateStr=LEFT(m.lcDateStr,m.liLen-1) 

      * datumov oddlova
      liLen=__DTCLASS_GetLocaleInfo(__DTCLASS_GetThreadLocale(),LOCALE_SDATE,@m.lcDateMark,LEN(m.lcDateMark))
      lcDateMark=LEFT(m.lcDateMark,m.liLen-1)
  
      lcMask=UPPER(m.lcDateStr)
      lcMask=STRTRAN(m.lcMask,REPL("D",OCCURS("D",m.lcMask)),"99")
      lcMask=STRTRAN(m.lcMask,REPL("M",OCCURS("M",m.lcMask)),"99")
      lcMask=STRTRAN(m.lcMask,REPL("Y",OCCURS("Y",m.lcMask)),IIF(m.liCentury=1,"9999","99"))
      lcMask=STRTRAN(m.lcMask,m.lcDateMark,"#")
      RETURN m.lcMask
   ENDPROC

   PROCEDURE GetStringBlankDate(loTXT) && Konverze przdnho datumu na etzec
      * loTXT  - .NULL. nebo odkaz na textbox s datumem (Date/string)

      * nejdve musm zjisti formtovn vstupu
      * pokud je formtovn Default, pak jej musm zjistit dle SET("DATE")
      * pak z datumu natu zvl᚝ den, msc a rok
      * datumov oddlova se nat z vlastnosti DateMark
      * pokud je EMPTY(), pak se bere z nastaven SET("MARK")
      * nsledn slom etzec, kter vrtm

      LOCAL luDateFormat,lcDateMark,lcDate,liLen,liCentury,lcCentury
      This.oTXT=loTXT
      luDateFormat=This.GetDateFormat(This.DateFormat)
      lcDateMark=IIF(EMPTY(This.DateMark),SET("MARK"),This.DateMark)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.

      lcCentury=IIF(m.liCentury=1,"    ","  ")
      IF m.luDateFormat=DateTF_Short && short
         lcDate=STRTRAN(This.GetShortDateFormatString(),"#",m.lcDateMark)

         lcDate=STRTRAN(m.lcDate,REPL("D",OCCURS("D",m.lcDate)),"  ")
         lcDate=STRTRAN(m.lcDate,REPL("M",OCCURS("M",m.lcDate)),"  ")
         lcDate=STRTRAN(m.lcDate,REPL("Y",OCCURS("Y",m.lcDate)),m.lcCentury)
      ELSE
         IF m.luDateFormat=DateTF_Long
         ELSE
            * mm/dd/yy   MDY
            * yy.mm.dd   YMD
            * dd/mm/yy   DMY
            lcDate=IIF(INLIST(m.luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY),"  "+m.lcDateMark+"  "+m.lcDateMark+m.lcCentury,;
                   IIF(INLIST(m.luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD),m.lcCentury+m.lcDateMark+"  "+m.lcDateMark+"  ","  "+m.lcDateMark+"  "+m.lcDateMark+m.lcCentury))
             
         ENDIF
      ENDIF
      RETURN m.lcDate
   ENDPROC


   PROTECTED PROCEDURE GetAutomaticDate(lcDate,liY,liM,liD) && Vrt automatick datum
      * lcDate - Datum v etzcovm typu
      * liY - poten znak roku
      * liM - poten znak msce
      * liD - poten znak dne

      LOCAL lcPom,lii,lcAFD,ldDate,liCentury
      * test na zkrcen zadvn
      * vem prvn dv pozice a oe mezery
      * hledej v seznamu ,xx:
      * pokud najde, pekduj dle parametru za :
      * 0, je aktuln den, jinak poad dne v tdnu
      liCentury=This.GetCentury(This.Century)
      lcAFD=This.AutoFillDate_Data(This.AutoFillDateMode)
      lcPom=ALLT(LEFT(m.lcDate,2))
      lii=ATC(","+m.lcPom+":",m.lcAFD)
      IF m.lii>0
         lcPom=SUBST(m.lcAFD,m.lii+LEN(","+m.lcPom+":"))
         lii=ATC(",",m.lcPom)
         IF m.lii>0
            lii=VAL(LEFT(m.lcPom,m.lii-1)) && 
            ldDate=IIF(m.lii=0,DATE(),DATE()- (DOW(DATE(),SET("FDOW"))-m.lii))
         ENDIF

         lcDate=STUFF(m.lcDate,liY,IIF(m.liCentury=1,4,2),STR(YEAR(m.ldDate),IIF(m.liCentury=1,4,2)))
         lcDate=STUFF(m.lcDate,liM,2,STR(MONTH(m.ldDate),2))
         lcDate=STUFF(m.lcDate,liD,2,STR(DAY(m.ldDate),2))
   
         RETURN CHRTRAN(m.lcDate," ","0")
      ENDIF
      RETURN .NULL.
   ENDPROC
   
   PROCEDURE SetFormatString(loTXT) && Nastav Format a InputString dle pslunch regionlnch nastaven
      * loTXT  - .NULL. nebo odkaz na textbox s datumem (Date/string)

      * nejdve musm zjisti formtovn vstupu
      * pokud je formtovn Default, pak jej musm zjistit dle SET("DATE")
      * pak z datumu natu zvl᚝ den, msc a rok
      * datumov oddlova se nat z vlastnosti DateMark
      * pokud je EMPTY(), pak se bere z nastaven SET("MARK")
      * nsledn slom etzece formtovn

      LOCAL lcMask,luDateFormat,lcDateMark,liCentury
      This.oTXT=loTXT
      luDateFormat=This.GetDateFormat(This.DateFormat)
      lcDateMark=IIF(EMPTY(This.DateMark),SET("MARK"),This.DateMark)
      liCentury=This.GetCentury(This.Century)
      IF m.luDateFormat=DateTF_Short && short
         lcMask=This.GetShortDateFormatString()
      ELSE
         IF luDateFormat=DateTF_Long && long
            lcMask=""
         ELSE
            * mm/dd/yy   MDY
            * yy.mm.dd   YMD
            * dd/mm/yy   DMY
            lcMask=IIF(INLIST(m.luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY),"99#99#99"+IIF(m.liCentury=1,"99",""),;
                   IIF(INLIST(m.luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD),IIF(m.liCentury=1,"99","")+"99#99#99","99#99#99"+IIF(m.liCentury=1,"99","")))
         ENDIF
      ENDIF

      IF This.AutoFillDate=1
         This.Format="XX"+SUBST(m.lcMask,3)
         This.InputMask="XX"+SUBST(STRTRAN(m.lcMask,"#",m.lcDateMark),3)
      ELSE
         This.Format=m.lcMask
         This.InputMask=STRTRAN(m.lcMask,"#",m.lcDateMark)
      ENDIF
      This.oTXT=.NULL.
   ENDPROC

   PROCEDURE IncDec(loTXT,liDelta,liSelStart,liSelLength) && Poven/ponen dne/msce/roku
      * loTXT  - odkaz na textbox s datumem (Date/string)
      IF loTXT.Text=This.GetStringBlankDate(m.loTXT)
         RETURN loTXT.Value
      ENDIF

      LOCAL luDateFormat,liY,liM,liD,liDelta,lcType,luValue,liCentury
      lcType=VARTYPE(m.loTXT.Value)
      This.oTXT=loTXT
      luDateFormat=This.GetDateFormat(m.loTXT.DateFormat)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.

      DO CASE
         CASE m.luDateFormat=DateTF_Long && long
              STORE 0 TO liY,liM,liD

         CASE m.luDateFormat=DateTF_Short && short
              lcDateStr=This.GetShortDateFormatString(m.loTXT)

              liY=AT(IIF(m.liCentury=1,"YYYY",'YY'),m.lcDateStr)
              liM=AT("MM",m.lcDateStr)
              liD=AT("DD",m.lcDateStr)

         CASE INLIST(m.luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY)
              liY=7
              liM=1
              liD=4

         CASE INLIST(m.luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD)
              liY=1
              liM=IIF(m.liCentury=1,6,4)
              liD=IIF(m.liCentury=1,9,7)

         OTHERWISE
              liY=7
              liM=4
              liD=1

     ENDCASE

     DO CASE
        CASE BETWEEN(m.liSelStart+1,m.liD,m.liD+1)
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.ToDate(m.loTXT,m.loTXT.Value)+m.liDelta*1)
             ELSE
                luValue=m.loTXT.Value+m.liDelta*1
             ENDIF
             liSelStart=m.liD-1
             liSelLength=2
     
        CASE BETWEEN(m.liSelStart+1,m.liM,m.liM+1)
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,GOMONTH(This.ToDate(m.loTXT,m.loTXT.Value),m.liDelta*1))
             ELSE
                luValue=GOMONTH(m.loTXT.Value,m.liDelta*1)
             ENDIF
             liSelStart=m.liM-1
             liSelLength=2
        
        CASE BETWEEN(m.liSelStart+1,m.liY,m.liY+IIF(m.liCentury=1,3,1))
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,GOMONTH(This.ToDate(m.loTXT,m.loTXT.Value),m.liDelta*12))
             ELSE
                luValue=GOMONTH(m.loTXT.Value,m.liDelta*12)
             ENDIF
             liSelStart=m.liY-1
             liSelLength=IIF(m.liCentury=1,4,2)

     ENDCASE
     RETURN luValue
   ENDPROC
ENDDEFINE






DEFINE CLASS _DATETIME AS _DATE
   Name="_DATETIME"

   TimeSeparator=.NULL.

   PROCEDURE TimeSeparator_Access
      LOCAL lcTS,lii
      lcTS=REPLICATE(CHR(0),20)
      lii=__DTCLASS_GetLocaleInfo(__DTCLASS_GetThreadLocale(),LOCALE_STIME,@m.lcTS,LEN(m.lcTS))
      RETURN LEFT(m.lcTS,m.lii-1)
   ENDPROC

   PROCEDURE GoMonth(ldDateTime,liDelta)
      * ldDateTime - datetime
      LOCAL lcTime
      lcTime=RIGHT(TTOC(m.ldDateTime),9)
      RETURN CTOT("^"+LEFT(TTOC(GOMONTH(m.ldDateTime,m.liDelta),3),10)+m.lcTime) 
   ENDPROC
   
   PROCEDURE ToDate(loTXT,lcDate) && Konverze datumu v etzcovm tvaru na datum
      * loTXT  - .NULL. nebo odkaz na textbox s datumem a asem (Date/string)
      * lcDate - Datum a as v etzcovm typu
      LOCAL ldDate,liCentury
      liCentury=This.GetCentury(This.Century)
      ldDate=DODEFAULT(m.loTXT,LEFT(m.lcDate, IIF(m.liCentury=1,10,8)))
      RETURN CTOT("^"+LEFT(TTOC(m.ldDate,3),10)+SUBSTR(m.lcDate,IIF(m.liCentury=1,11,9))) 
   ENDPROC

   PROCEDURE ToString(loTXT,ldDateTime) && Konverze datumu na etzec
      * loTXT  - .NULL. nebo odkaz na textbox s datumem a asem (Date/string)
      * ldDate - Datum
      LOCAL lcDate,lcTime,lcTS
      lcDate=DODEFAULT(m.loTXT,TTOD(m.ldDateTime))
      lcTime=RIGHT(TTOC(m.ldDateTime,1),6)
      lcTS=This.TimeSeparator
      * pidej k tomu as
      RETURN m.lcDate+" "+LEFT(m.lcTime,2)+m.lcTS+SUBST(m.lcTime,3,2)+m.lcTS+RIGHT(m.lcTime,2)
   ENDPROC


   PROCEDURE GetShortDateFormatString(loTXT) && Vrt formtovac etzec pro Short Date
      * loTXT  - .NULL. nebo odkaz na textbox s datumem a asem (Date/string)
      RETURN DODEFAULT(m.loTXT)+STRTRAN(" 99#99#99","#",This.TimeSeparator)
   ENDPROC

   PROCEDURE SetFormatString(loTXT) && Nastav Format a InputString dle pslunch regionlnch nastaven
      * loTXT  - .NULL. nebo odkaz na textbox s datumem a asem (Date/string)
      DODEFAULT(m.loTXT)
      LOCAL lcMaskT,lcTS
      This.oTXT=loTXT
      lcMaskT=" 99#99#99"
      lcTS=This.TimeSeparator
      This.Format=This.Format+STRTRAN(m.lcMaskT,"#",m.lcTS)
      This.InputMask=This.InputMask+STRTRAN(m.lcMaskT,"#",m.lcTS)
      This.oTXT=.NULL.
   ENDPROC


   PROCEDURE IncDec(loTXT,liDelta,liSelStart,liSelLength) && Poven/ponen dne/msce/roku
      * loTXT  - .NULL. nebo odkaz na textbox s datumem a asem (Date/string)
      IF loTXT.Text=This.GetStringBlankDate(m.loTXT)
         RETURN loTXT.Value
      ENDIF

      LOCAL luDateFormat,liY,liM,liD,liDelta,lcType,luValue,liCentury,liHH,liMI,liSS
      lcType=VARTYPE(m.loTXT.Value)
      This.oTXT=loTXT
      luDateFormat=This.GetDateFormat(m.loTXT.DateFormat)
      liCentury=This.GetCentury(This.Century)
      This.oTXT=.NULL.

      DO CASE
         CASE m.luDateFormat=DateTF_Long && long
              STORE 0 TO liY,liM,liD

         CASE m.luDateFormat=DateTF_Short && short
              lcDateStr=This.GetShortDateFormatString(m.loTXT)

              liY=AT(IIF(m.liCentury=1,"YYYY",'YY'),m.lcDateStr)
              liM=AT("MM",m.lcDateStr)
              liD=AT("DD",m.lcDateStr)

         CASE INLIST(m.luDateFormat,DateTF_American,DateTF_USA,DateTF_MDY)
              liY=7
              liM=1
              liD=4

         CASE INLIST(m.luDateFormat,DateTF_Ansi,DateTF_Japan,DateTF_Taiwan,DateTF_YMD)
              liY=1
              liM=IIF(m.liCentury=1,6,4)
              liD=IIF(m.liCentury=1,9,7)

         OTHERWISE && MDY     MM.DD.YYYY HH:MI:SS
              liY=7
              liM=4
              liD=1

     ENDCASE
     liHH=12-IIF(m.liCentury=1,0,2)
     liMI=15-IIF(m.liCentury=1,0,2)
     liSS=18-IIF(m.liCentury=1,0,2)

     DO CASE
        CASE BETWEEN(m.liSelStart+1,m.liD,m.liD+1)
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.ToDate(m.loTXT,m.loTXT.Value)+m.liDelta*1*60*60*24)
             ELSE
                luValue=m.loTXT.Value+m.liDelta*1*60*60*24
             ENDIF
             liSelStart=m.liD-1
             liSelLength=2
     
        CASE BETWEEN(m.liSelStart+1,m.liM,m.liM+1)
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.GOMONTH(This.ToDate(m.loTXT,m.loTXT.Value),m.liDelta*1))
             ELSE
                luValue=This.GOMONTH(m.loTXT.Value,m.liDelta*1)
             ENDIF
             liSelStart=m.liM-1
             liSelLength=2
        
        CASE BETWEEN(m.liSelStart+1,m.liY,m.liY+IIF(m.liCentury=1,3,1))
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.GOMONTH(This.ToDate(m.loTXT,m.loTXT.Value),m.liDelta*12))
             ELSE
                luValue=This.GOMONTH(m.loTXT.Value,m.liDelta*12)
             ENDIF
             liSelStart=m.liY-1
             liSelLength=IIF(m.liCentury=1,4,2)

        CASE BETWEEN(m.liSelStart+1,m.liHH,m.liHH+1) && Hours
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.ToDate(m.loTXT,m.loTXT.Value)+m.liDelta*1*60*60)
             ELSE
                luValue=m.loTXT.Value+m.liDelta*1*60*60
             ENDIF
             liSelStart=m.liHH-1
             liSelLength=2

        CASE BETWEEN(m.liSelStart+1,m.liMI,m.liMI+1) && Minutes
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.ToDate(m.loTXT,m.loTXT.Value)+m.liDelta*1*60)
             ELSE
                luValue=m.loTXT.Value+m.liDelta*1*60
             ENDIF
             liSelStart=m.liMI-1
             liSelLength=2

        CASE BETWEEN(m.liSelStart+1,m.liSS,m.liSS+1) && Seconds
             IF m.lcType="C"
                luValue=This.ToString(m.loTXT,This.ToDate(m.loTXT,m.loTXT.Value)+m.liDelta)
             ELSE
                luValue=m.loTXT.Value+m.liDelta
             ENDIF
             liSelStart=m.liSS-1
             liSelLength=2

     ENDCASE
     RETURN luValue
   ENDPROC

ENDDEFINE
